org.eclipse.viatra.query.runtime.rete.construction.plancompiler

## Class RecursionCutoffPoint

- java.lang.Object
- - org.eclipse.viatra.query.runtime.rete.construction.plancompiler.RecursionCutoffPoint

-     public class RecursionCutoffPoint
      extends java.lang.Object

  In a recursive query structure, query composition references can be cut off so that the remaining structure is DAG. `RecursionCutoffPoint` represents one such cut off query composition. When the compilation of the recursive query finishes and the compiled form becomes available, the `RecursionCutoffPoint` has to be signaled to update parent traces and recipes of the recursive call.
  No Reference:
    This class is not intended to be referenced by clients

- - ### Constructor Summary

    Constructors
    Constructor and Description
    `RecursionCutoffPoint(PQuery query, QueryEvaluationHint hint, IQueryMetaContext context, boolean deleteAndRederiveEvaluation, TimelyConfiguration timelyEvaluation)`

  - ### Method Summary

    All Methods Instance Methods Concrete Methods
    Modifier and Type | Method and Description
    --- | ---
    `CompiledQuery` | `getCompiledQuery()`
    `ProductionRecipe` | `getRecipe()`
    `void` | `mend(CompiledQuery finalCompiledForm)` Signals that compilation of the recursive query has terminated, culminating into the given compiled form.

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- - ### Constructor Detail

    - #### RecursionCutoffPoint

          public RecursionCutoffPoint(PQuery query,
                                      QueryEvaluationHint hint,
                                      IQueryMetaContext context,
                                      boolean deleteAndRederiveEvaluation,
                                      TimelyConfiguration timelyEvaluation)

  - ### Method Detail

    - #### mend

          public void mend(CompiledQuery finalCompiledForm)

      Signals that compilation of the recursive query has terminated, culminating into the given compiled form. The query composition that has been cut off will be connected now.

    - #### getCompiledQuery

          public CompiledQuery getCompiledQuery()

    - #### getRecipe

          public ProductionRecipe getRecipe()